#!/usr/bin/python
# -*- coding: utf-8 -*-
# Copyright (c) 2006 UbuntuChina <http://www.ubuntu.org.cn>
# License: GPLv2
# Author: oneleaf <oneleaf AT gmail.com>
# Version: 0.4

from BitTorrent.platform import install_translation
install_translation()

import sys
import os
import threading
from time import sleep, time, strftime
from BitTorrent.download import Feedback, Multitorrent
from BitTorrent.defaultargs import get_defaults
from BitTorrent.bencode import bdecode
from BitTorrent.ConvertedMetainfo import ConvertedMetainfo
from BitTorrent.prefs import Preferences
from BitTorrent import configfile
from BitTorrent import BTFailure
from BitTorrent import GetTorrent
import BaseHTTPServer,SocketServer
import httplib
from BitTorrent import download, bencode, makemetafile
from distutils import dir_util   

class RequestHandler(BaseHTTPServer.BaseHTTPRequestHandler):
    def do_GET(self):
        getfile(self,self.path)

btpath="/share/bt/btfiles"
archivepath="/share"
stoptime=3600
timeout=60
btfilesize=200000

def getfile(self,url):
    file=archivepath+url
    if url=="" or url=="/" or url=="\\":
        self.send_response(200)
        self.send_header("content-type","text/html")
        self.end_headers()
        self.wfile.write("<HTML>\n")
        self.wfile.write("<HEAD>\n")
        self.wfile.write("<TITLE>Index of "+url+"</TITLE>\n")
        self.wfile.write("</HEAD>\n")
        self.wfile.write("<BODY>\n")
        self.wfile.write("<h1>Index of /</h1>")
        self.wfile.write("<ul>")
        self.wfile.write("<li><a href=\"ubuntu\">ubuntu/</a>\n</li>")
        self.wfile.write("<li><a href=\"ubuntu-cn\">ubuntu-cn/</a></li>\n")
        self.wfile.write("</ul>")
        self.wfile.write("<address>Bt Server</address>\n")
        self.wfile.write("</BODY>\n")
        self.wfile.write("</HTML>\n")
        return
    if not os.path.exists(file):
        self.send_response(403,"No File Find")
        self.send_header("content-type","text/html")
        self.end_headers()
        self.wfile.write("No File Find!")
        return
    if os.path.isdir(file):
        self.send_response(200)
        self.send_header("content-type","text/html")
        self.end_headers()
        self.wfile.write("<HTML>\n")
        self.wfile.write("<HEAD>\n")
        self.wfile.write("<TITLE>Index of "+url+"</TITLE>\n")
        self.wfile.write("</HEAD>\n")
        self.wfile.write("<BODY>\n")
        self.wfile.write("<h1>Index of "+url+"</h1>")
        if url[len(url)-1]<>"/":url=url+"/"
        self.wfile.write("<ul>")
        self.wfile.write("<li><a href=\""+url[:url.rfind('/',0,len(url)-1)+1]+"\">Parent Directory</a></li>\n")
        for mfile in os.listdir(file):
            if os.path.isdir(file+"/"+mfile):
                if mfile[len(mfile)-1]<>"/":mfile=mfile+"/"
                self.wfile.write("<li><a href=\""+url+mfile+"\">"+mfile+"</a></li>\n")
            else:
                size=os.path.getsize(file+"/"+mfile)
                if size>btfilesize:
                    self.wfile.write("<li><a href=\""+url+mfile+"\">"+mfile+"[BT]</a>  "+str(size)+"</li>\n")
                else:
                    self.wfile.write("<li><a href=\""+url+mfile+"\">"+mfile+"</a>  "+str(size)+"</li>\n")                   
        self.wfile.write("</ul>")
        self.wfile.write("<address>Bt Server</address>\n")
        self.wfile.write("</BODY>\n")
        self.wfile.write("</HTML>\n")
    else:
        filesize=os.path.getsize(file)
        if filesize<btfilesize:
            self.send_response(200)
            self.send_header("content-type","file")
            self.send_header("Content-Disposition","attachment;filename="+file[file.rfind('/')+1:])
            self.send_header("Content-length",filesize)
            self.end_headers()
            self.wfile.write(open(file).read())                       
        else:
            btfile=btpath+url+'.torrent'
            makebtfile(btfile,file)
            if os.path.exists(btfile) and loadbtfile(btfile,file)==1:
                self.send_response(200)
                self.send_header("content-type","file")
                self.send_header("Content-Disposition","attachment;filename="+btfile[btfile.rfind('/')+1:])
                self.send_header("Source-length",filesize)
                self.end_headers()
                self.wfile.write(open(btfile).read())           
            else:
                self.send_response(403,"No File Find")
                self.send_header("content-type","text/html")
                self.end_headers()
                self.wfile.write("No File Find!")           
           

def loadbtfile(btfile,debfile):
    bts.addbtfile(btfile,debfile)
    while 1:
        if bts.torrentlist.has_key(btfile):break
    while not bts.torrentlist[btfile][0].done:
       sleep(1)
    if bts.torrentlist[btfile][0].done:
        print "download",debfile[debfile.rfind('/')+1:],"end."           
        return 1     
    print "download",debfile[debfile.rfind('/')+1:],"error!"
    return 0

def makebtfile(btfile,file):
    dir_util.mkpath(os.path.split(btfile)[0])
    url="http://bt.ubuntu.org.cn:6969/announce"
    btmakemetafile.make_meta_file(file, url, piece_len_exp=16 ,target=btfile)


class btserverFreebak(Feedback):
    def __init__(self,multitorrent):
        self.doneflag = threading.Event()
        self.done=False
        self.file = ''
        self.downloadTo = ''
        self.fileSize = ''
        self.numpieces = 0
        self.percentDone=0.0
        self.downRate = 0
        self.torrent=None
        self.multitorrent=multitorrent

    def error(self, torrent, level, text): print text
    def failed(self, torrent, is_external): self.join()
    def finished(self, torrent): self.done=True
    def set_torrent_values(self, name, path, size, numpieces,torrent):
        self.file = name
        self.downloadTo = path
        self.fileSize = size
        self.numpieces = numpieces
        self.torrent=torrent
        self.get_status()
    def get_status(self):
        self.multitorrent.rawserver.add_task(self.get_status,1)
        statistics = self.torrent.get_status(None)
        if not self.done:
            fractionDone = statistics.get('fractionDone')
            activity = statistics.get('activity')
            downRate = statistics.get('downRate')
            if fractionDone is not None:
                self.percentDone = str(int(fractionDone * 1000) / 10)+'%'
            if downRate is not None:
                self.downRate = '%.1f KB/s' % (downRate / (1 << 10))
            print self.file,self.percentDone,self.downRate,activity

    def join(self):
        if not self.doneflag is None:
            self.doneflag.set()
            self.doneflag=None

class btserver(object):
    def __init__(self):
        defaults=get_defaults('bittorrent')
        self.torrentlist={}
        self.doneflag = threading.Event()
        config, args = configfile.parse_configuration_and_args(defaults,'bittorrent',[], 0, 1)
        self.config = Preferences().initWithDict(config)
        self.multitorrent = Multitorrent(self.config, self.doneflag,self.global_error)
        self.rawserver = self.multitorrent.rawserver
        self.rawserver.install_sigint_handler()
        thread=threading.Thread(None, self.multitorrent.rawserver.listen_forever, "btserver")        
        thread.start()
        self.needadd=[]
        self.doingtime=72000;
        self.down()

    def global_error(self, level, text): print text

    def addbtfile(self,btfile,saveas):
        self.needadd.append([btfile,saveas])

    def down(self):
        self.multitorrent.rawserver.add_task(self.down,0.5)
        while 1:
            if len(self.needadd)==0: break
            bt=self.needadd[0]
            if not self.torrentlist.has_key(bt[0]):
                torrentfile=bt[0]
                saveas=bt[1]
                metainfo, errors = GetTorrent.get(torrentfile)
                if errors:
                    print errors
                    break
                metainfo = ConvertedMetainfo(bdecode(metainfo))
                btfb= btserverFreebak(self.multitorrent)
                torrent = self.multitorrent.start_torrent(metainfo,
                               Preferences(self.config), btfb, saveas)
                btfb.set_torrent_values(metainfo.name, os.path.abspath(saveas),
                                        metainfo.total_bytes, len(metainfo.hashes),
                                        torrent)
                self.torrentlist[torrentfile]=[btfb,self.doingtime]
            else: 
                self.torrentlist[torrentfile][1]=self.doingtime
            del self.needadd[0]
        for btfile in self.torrentlist.keys():
            self.torrentlist[btfile][1]=self.torrentlist[btfile][1]-1
            if self.torrentlist[btfile][1]<1 and (self.torrentlist[btfile][0].done==True or self.torrentlist[btfile][0].percentDone==0.0):
                self.torrentlist[btfile][0].join()
                os.remove(self.torrentlist[btfile][0].file)

    def join(self):
        try:
            for torrentfile in self.torrentlist.keys():
                self.torrentlist[torrentfile][0].join()
                os.remove(self.torrentlist[btfile][0].file)
                os.remove(self.torrentlist[btfile][0].downloadTo)
        finally:
            if not self.doneflag is None:
                self.doneflag.set()
                self.doneflag=None

bts=btserver()


class myWebServer(SocketServer.ThreadingMixIn,BaseHTTPServer.HTTPServer): pass
       
if __name__ == "__main__":
    try:
        server = myWebServer(('', 8080), RequestHandler)
        server.serve_forever()
    finally:
        bts.join()
